function [F,inliers] = BLOGS_alg(filename1,filename2,output_name)
    %BLOGS parameters initialization
    paramBLOGS.alpha = 0.5;   %suggested mixing parameter
    paramBLOGS.beta = 0;      %degeneracy parameter (can be increased upto 0.01)
                              %Algorithm is little faster if not used (0).
    paramBLOGS.tau = 10000;   %suggested 
    paramBLOGS.sample_size = 8; % 7-points or 8-points. We suggest 7-points
    paramBLOGS.iter = 10000;    % number of iterations.
    paramBLOGS.treshold = 5;

    [im1 ML1 MD1 row1 col1] = one_image_analysis1(filename1);
    MD1 = MD1';
    ML1 = [ML1([2 1 3],:); -ML1(4,:)]';        
    [im2 ML2 MD2 row2 col2] = one_image_analysis1(filename2);
    MD2 = MD2';
    ML2 = [ML2([2 1 3],:); -ML2(4,:)]';        

    [x1, x2, p_samp] = sift_match( MD1, ML1, MD2, ML2);
    ind = get_best_MAX_NUM_POINTS(1:length(p_samp));
    x1 = x1(:,ind);
    x2 = x2(:,ind);
    p_samp = p_samp(ind);
    p_samp = cumsum(p_samp(:)'/sum(p_samp));

    imSz(1,1) = row1;
    imSz(1,2) = col1;
    imSz(2,1) = row2;
    imSz(2,2) = col2;

    [optind,soft_est_num_inliers,inlier_rate,inliers,F_stam] = BLOGS(x1, x2, p_samp, imSz, paramBLOGS);
    F =fundmatrix(x1(:,inliers),x2(:, inliers));
    inliers = [x1(1:2,inliers);x2(1:2,inliers)];
    F = reshape(F',1,9);
end

