%% Version 2.0 BlOGS Code
%% Please refer to log_of_changes.txt for a list of changes over the previous version.
%% (c) 2011 University of South Florida, Tampa
%% All rights reserved
%% Use, or copying without permission prohibited.
%% This permission may be granted only by Prof. Sudeep Sarkar of University
%% of South Florida (sarkar@cse.usf.edu).  
%%
%%     This program is free software for research and educational purposes
%%     ONLY. For these purposes, you can redistribute it and/or modify it
%%     under the terms of the GNU General Public License as published by
%%     the Free Software Foundation, either version 3 of the License, or
%%     (at your option) any later version. This program is distributed in
%%     the hope that it will be useful, but WITHOUT ANY WARRANTY; without
%%     even the implied warranty of MERCHANTABILITY or FITNESS FOR A
%%     PARTICULAR PURPOSE.  See the GNU General Public License for more
%%     details. You should have received a copy of the GNU General Public
%%     License along with this program.  If not, see
%%     <http://www.gnu.org/licenses/>.
%%
%%
%%    BEFORE ANY RESULTS OR OUTPUT OF THIS PROGRAM ARE DISTRIBUTED TO THIRD
%%    PARTY, e.g. in publications, reports, etc., THEY HAVE TO BE SHARED
%%    WITH Prof. Sudeep Sarkar of University of South Florida (sarkar@cse.usf.edu). 
%%
%%    AUTHOR OF CODE: Aveek Brahmachari (abrahmac@mail.usf.edu)
%% 
%% Acknowledgment as appropriate is respectfully requested to 
%%
%% Brahmachari, A.S.; Sarkar, S.; , "BLOGS: Balanced local and global
%% search for non-degenerate two view epipolar geometry," Computer Vision,
%% 2009 IEEE 12th International Conference on , vol., no., pp.1685-1692,
%% Sept. 29 2009-Oct. 2 2009 doi: 10.1109/ICCV.2009.5459379

function [Q] = degeneracy_measure(x1, x2)
    count = size(x1,2);
    Q = double(zeros(count, count));
    for i = 1: count-1
        for j = i+1: count
            xp1(:,1) = x1(:,i);
            xp2(:,1) = x2(:,i);

            xp1(:,2) = x1(:,j);
            xp2(:,2) = x2(:,j);

            Q(i,j) = corrinfo(xp1,xp2);
            Q(j,i) = Q(i,j);
        end
    end
end