function [support, prob] = p_symmetric_epipolar_distance(F,xx1,xx2,sz)
    q = F*xx1;
    r = F'*xx2;

    s = q.*q;
    t = r.*r;

    u = 1./(s(1,:) + s(2,:) + t(1,:)+ t(2,:));
    
    m = sum(xx2.*q);
    px = m.*m.*u;
    
    prob = exp(-px*sqrt(sz(1,1)*sz(1,2)*sz(2,1)*sz(2,2))/25);
    support = sum(prob(prob>= 0.95));
end