 function [x1new, x2new, p] = sift_match( des1, loc1, des2, loc2)

     X = des1*des2';
     G = 1./(2*(1-X));
     
     if ((size(G,1) > 5000) || (size(G,2) > 5000))
         MX11 = zeros(1,size(G,1));
         IX1 = zeros(1,size(G,1));
         for i = 1:size(G,1)
             [MX11(i),IX1(i)] = max(G(i,:));
         end
     else
         H = G';
         [MX11,IX1] = max(H);
     end
     [MX21,IX2] = max(G);

     sz = size(des1,1);
     if(sz > size(des2,1))
         sz = size(des2,1);
     end
     
     if(size(des1,1)<2 || size(des2,1)<2)
        PhotoSim = 0;
     else
         if(IX1~=0)
             for i =  1: size(des1,1)
                H(IX1(i),i) = 0;
             end
         end

         if(IX2~=0)
             for j =  1: size(des2,1)
                G(IX2(j),j) = 0;
             end
         end

         MX12 = max(H);
         MX22 = max(G);
 
         a = (1-(MX12(:)./MX11(:))).*(1- exp(-MX11(:)));
         u = IX1(:);

         b = (1-(MX22(:)./MX21(:))).*(1- exp(-MX21(:)));
         v = IX2(:);

         count=0;
         for i = 1 : size(des1,1)     
             for j = 1 : size(des2,1)
                 if(((v(j)== i)&&(u(i)==j)))
                     count=count+1;
                 end
             end
         end

        MAPCONF = double(zeros(count,1));
        MAP = double(zeros(count,2));  

        count = 0;
        for i = 1 : size(des1,1)     
            for j = 1 : size(des2,1)
                if(((v(j)== i)&&(u(i)==j)))
                    count=count+1;
                    MAPCONF(count)= a(i)*b(j);
                    MAP(count,1)= i;
                    MAP(count,2)= j;    
                end
            end
        end

        [P, IX] = sort(MAPCONF,'descend');
        NEWMAP = double(zeros(count,2));  
        for i = 1 : count
            NEWMAP(i, 1) = MAP(IX(i), 1);
            NEWMAP(i, 2) = MAP(IX(i), 2);
        end

        x1 = double(zeros(3, count));
        x2 = double(zeros(3, count));

        for i = 1: count
             x1(1,i) = loc1(NEWMAP(i,1),2);     
             x1(2,i) = loc1(NEWMAP(i,1),1);
             x1(3,i) = 1;
             x2(1,i) = loc2(NEWMAP(i,2),2);
             x2(2,i) = loc2(NEWMAP(i,2),1);
             x2(3,i) = 1;
        end

        % select only distinct x1 and x2
        % remove those that appear later

        i = 1;
        while(i<count-1)
            j = i+1;
            while(j<count)
                if(((x1(1,i) == x1(1,j))&&(x1(2,i) == x1(2,j)))||((x2(1,i) == x2(1,j))&&(x2(2,i) == x2(2,j))))
                    for k = j : count-1
                        x1(1,k) = x1(1,k+1);
                        x1(2,k) = x1(2,k+1);
                        x1(3,k) = x1(3,k+1);
                        x2(1,k) = x2(1,k+1);
                        x2(2,k) = x2(2,k+1);
                        x2(3,k) = x2(3,k+1);
                        P(k) = P(k+1);
                    end
                    count = count - 1;
                    j = j - 1;
                end
                j = j+1;
            end
            i = i+1;
        end

        x1new = double(zeros(3, count));
        x2new = double(zeros(3, count));
        Pnew = double(zeros(count,1));

        for k = 1 : count
            x1new(1,k) = x1(1,k);
            x1new(2,k) = x1(2,k);
            x1new(3,k) = x1(3,k);
            x2new(1,k) = x2(1,k);
            x2new(2,k) = x2(2,k);
            x2new(3,k) = x2(3,k);
            Pnew(k) = P(k);
        end
        p = Pnew;
%         p = cumsum(Pnew(:)'/sum(Pnew));
     end
 end