function BLOGS_after_us(im1,im2,out)        
    global MAX_NUM_POINTS
    sum_MAX_NUM_POINTS = [];
    for ind = 1:length(out)
        sum_MAX_NUM_POINTS(ind) = sum(out(ind).probabilities(1:min(MAX_NUM_POINTS,length(out(ind).probabilities))))*length(out(ind).probabilities)/400;
    end
    [~, ind_list] = sort(sum_MAX_NUM_POINTS,'descend');
    N = zeros(1,length(out));
    for ind = ind_list
        output(ind) = BLOGS_alg(out(ind),ind,im1,im2);
        N(ind) = size(output(ind).inliers,2);
    end    
    [~, ind] = max(N);
    BLOGS_output = output(ind);    
    save('BLOGS_output.mat', 'BLOGS_output');
end

function inliers = inliers_from_F(ordered_fm,F)
    global TRESHOLD; 
    
    [all_pairs_loc, unique_ind] = unique(ordered_fm([1:2 5:6],:)','rows');
    [~, dist]  = findFScore(F,all_pairs_loc);           
    inliers = ordered_fm([1:2 5:6],unique_ind(dist < TRESHOLD));    
end

function output = BLOGS_alg(out,j,im1,im2)    
    %BLOGS parameters initialization
    paramBLOGS.alpha = 0.5;   %suggested mixing parameter
    paramBLOGS.beta = 0;      %degeneracy parameter (can be increased upto 0.01)
                              %Algorithm is little faster if not used (0).
    paramBLOGS.tau = 10000;   %suggested 
    paramBLOGS.sample_size = 8; % 7-points or 8-points. We suggest 7-points
    paramBLOGS.iter = 10000;    % number of iterations.
    paramBLOGS.treshold = 5;
    img1 = imread(im1);
    img2 = imread(im2);
    imSz(1,1) = size(img1,1);
    imSz(1,2) = size(img1,2);
    if j ~= 1                                                                           
        imSz(2,1) = size(img2,2);
        imSz(2,2) = size(img2,1);
    else
        imSz(2,1) = size(img2,1);
        imSz(2,2) = size(img2,2);
    end
    p_samp = cumsum(out.probabilities'/sum(out.probabilities));
    [optind,soft_est_num_inliers,inlier_rate,inliers,F] = BLOGS(out.matches(1:2,:), out.matches(5:6,:), p_samp, imSz, paramBLOGS);
    output.F =fundmatrix([out.matches(1:2,inliers); ones(1,length(inliers))],[out.matches(5:6,inliers); ones(1,length(inliers))]);
    output.inliers = inliers_from_F(out.matches,output.F);
end