function output = combining_probabilities(output,i)
    N_blogs = nnz(output(1).p_blogs);  
    N_beem = nnz(output(1).distratio);
    N = nnz(output(i).sfms);
    taken_blogs = zeros(1,N_blogs);
    taken_beem = zeros(1,N_beem);    
    blogs_match_map = zeros(max([output(1).x_blogs(5,:) output(1).x_beem(5,:) output(i).ordered_fm_sfms(5,:)]),max([output(1).x_blogs(10,:) output(1).x_beem(10,:) output(i).ordered_fm_sfms(10,:)]));
    beem_match_map = zeros(max([output(1).x_blogs(5,:) output(1).x_beem(5,:) output(i).ordered_fm_sfms(5,:)]),max([output(1).x_blogs(10,:) output(1).x_beem(10,:) output(i).ordered_fm_sfms(10,:)]));
    for ind = 1:N_blogs
        blogs_match_map(output(1).x_blogs(5,ind),output(1).x_blogs(10,ind)) = ind;
    end
    for ind =1:N_beem
        beem_match_map(output(1).x_beem(5,ind),output(1).x_beem(10,ind)) = ind;
    end
    fm = zeros(10,N);
    p = zeros(4,N);        
    for ind = 1:N
        blogs_found =  blogs_match_map(output(i).ordered_fm_sfms(5,ind),output(i).ordered_fm_sfms(10,ind));
        beem_found = beem_match_map(output(i).ordered_fm_sfms(5,ind),output(i).ordered_fm_sfms(10,ind));
        fm(:,ind) = output(i).ordered_fm_sfms(:,ind);
        p(1,ind) = output(i).sfms(ind);
        if blogs_found
            p(2,ind) = output(1).p_blogs(blogs_found(1));
            taken_blogs(blogs_found) = 1;
        else
            p(2,ind) = 0;
        end
        if beem_found
            p(3,ind) = output(1).distratio(beem_found(1));
            taken_beem(beem_found) = 1;
        else
            p(3,ind) = 1;
        end
    end
    if numel(ind)
        N_pairs = ind;
    else
        N_pairs = 0;
    end
    for ind = 1:N_blogs
        if ~taken_blogs(ind)
            N_pairs = N_pairs + 1;
            fm(:,N_pairs) = output(1).x_blogs(:,ind);
            p(1,N_pairs) = 0;
            p(2,N_pairs) = output(1).p_blogs(ind);
            beem_found = beem_match_map(output(1).x_blogs(5,ind),output(1).x_blogs(10,ind));
            if beem_found
                p(3,N_pairs) = output(1).distratio(beem_found(1));
                taken_beem(beem_found) = 1;
            else
                p(3,N_pairs) = 1;
            end                                
        end
    end
    for ind = 1:N_beem
        if ~taken_beem(ind)
            N_pairs = N_pairs + 1;
            fm(:,N_pairs) = output(1).x_beem(:,ind);
            p(1,N_pairs) = 0;
            p(3,N_pairs) = output(1).distratio(ind);
            p(2,N_pairs) = 0;
        end
    end      
%     p(4,1:N_pairs) = output(1).alpha*ones(1,N_pairs);               
    save_arff('all.arff',p');
    [~, classProbs] = weka_predictor('all.arff');        
    [sorted_fm, ind_fm] = sort(classProbs(:,1),'descend');       
    output(i).ordered_fm = fm(:,ind_fm);            
    output(i).probabilities = sorted_fm';
    output(i).ordered_fm_sfms = [];
    output(i).sfms = [];
end

 function save_arff(filename,data)
    fid = fopen(filename,'w');    
    fprintf(fid,'@relation sfms\n');
    fprintf(fid,'@attribute our_probability real\n');
    fprintf(fid,'@attribute blogs_probability real\n');
    fprintf(fid,'@attribute dist_ratio real\n');
%     fprintf(fid,'@attribute alpha real\n');
    fprintf(fid,'@attribute class {1,0}\n');
    fprintf(fid,'\n@data\n');
    fclose(fid);
    dlmwrite(filename,data, '-append');
 end

 function [predictedClass, classProbs] = weka_predictor(filename)
    testData = loadARFF(filename);
    temp = javaObject('weka.core.SerializationHelper');
    filename = java.lang.String('We\combined_J48.model'); 
    classifier = temp.read(filename);
    [predictedClass, classProbs] = wekaClassify(testData,classifier);
end