function  [deviation_error r]  = findFScore(F,x)
    mode = 'mex'; %  'matlab', 'mex','c'
    if numel(x)
        if strcmp(mode,'matlab')
            P1 = [x(:,1:2) ones(size(x,1),1)];
            P2 = [x(:,3:4) ones(size(x,1),1)];
            r = diag(P2*F*P1');
            l1 = F*P1';
            l2 = (P2*F)';
            r = r.^2./((l1(1,:).^2+l1(2,:).^2) + (l2(1,:).^2+l2(2,:).^2))';
        elseif strcmp(mode,'mex')
            r = SampsonDistance(F,x);
        elseif strcmp(mode,'c')
            save_file('F.txt',F);
            save_file('matches.txt',x);
            system('SampsonDistance');
            r = textread('distances.txt');
            r = r(3:length(r));
        end
    else
        r = [];
    end
    deviation_error = sum(r);        
end

function save_file(filename,A)
    fid = fopen(filename, 'wt');
    fprintf(fid, '%d\n%d\n', size(A));
    fprintf(fid, '%e\n', A);
%     fprintf(fid, '%6.2f\n', A);
    fclose(fid);    
end