function [I, loc, des, row, col] = one_image_analysis1(img)
    global MAX_POINTS;
    global IMAGE_NAME; IMAGE_NAME = img;
    
    I = imread(IMAGE_NAME);                   
    if (ndims(I) > 2)
        I2D = single(rgb2gray(I));
    else
        I2D = single(I);
    end
    [row, col] = size(I2D);             
    [loc des] = getSIFTFeatures(I);
    [scales ind] = sort(loc(3,:));
    des = des(:,ind(max(1,length(ind)-MAX_POINTS+1):length(ind)));
    loc = loc(:,ind(max(1,length(ind)-MAX_POINTS+1):length(ind)));
    N_locs = size(loc,2);
    loc = [loc(1:4,:); 1:N_locs];   
end

function  [loc, descriptors] = getSIFTFeatures(im)
    if size(im,3) > 1
        im = rgb2gray(im);
    end;
    im = double(im);
    im = im-min(im(:));
    im = im/max(im(:));

    firstoctave = -1;
    if max(size(im)) > 1000
        firstoctave = max(0, firstoctave);
    end;
    numoctaves = min(floor(log2(min(size(im))))-firstoctave-3, 6);
    [loc, descriptors] = sift_my(im, 'numoctaves', numoctaves, 'firstoctave', firstoctave,'verbosity', 0);
end