function in_modes = one_image_analysis2(I,loc_angles,des_angles,angles_list)
    if angles_list == -100
        loc_zeros = loc_angles(1:4,:);
        des_zeros = des_angles;    
    else
        loc_zeros = zeros(4,size(loc_angles,2));
        des_zeros = zeros(size(des_angles));
        for i = 1:length(angles_list)        
            if size(I,3) >  1
                [loc_zeros(:,:,i),des_zeros(:,:,i)] = vl_sift(single(rgb2gray(I)),'frames',[loc_angles(1:3,:); angles_list(i)*ones(1,size(loc_angles,2))]);
            else
                [loc_zeros(:,:,i),des_zeros(:,:,i)] = vl_sift(single(I),'frames',[loc_angles(1:3,:); angles_list(i)*ones(1,size(loc_angles,2))]);
            end
            des_zeros(:,:,i) = descriptor_normalization(des_zeros(:,:,i));
        end    
    end
    in_modes = location_descriptor_clusters(I,loc_zeros(:,:,1),des_zeros(:,:,1));               
    for i =1:length(angles_list)        
        for cluster_ind = 1:size(in_modes.similar_descriptors_indeces,2)
            in_modes.similar_descriptors_values(:,cluster_ind,i) = find_cluster_descriptor(des_zeros(:,sort(nonzeros(in_modes.similar_descriptors_indeces(:,cluster_ind))),i));
        end
    end
end

function  in_modes = location_descriptor_clusters(im,loc,des)
    global DISPLAY_MODE;
    global CLUSTERING_THRESHOLD;
    global CLUSTERING_MINIMUM_SIZE;
    
    if strcmp(DISPLAY_MODE,'display')
        colours = ['r';'b';'g';'m';'y';'c';'k';'w';'r';'b';'g';'m';'y';'c';'k';'w';'r';'b';'g';'m';'y';'c';'k';'w';'r';'b';'g';'m';'y';'c';'k';'w'];
        marker = ['.';'o';'s';'v';'d';'p'];
        figure;imshow(im);
        hold on;
    end
    unique_loc = unique(loc(1:2,:)','rows')';
    N = size(unique_loc,2);
    loc_ind = zeros(1,N);
    for i = 1:N
        loc_ind((loc(1,:) == unique_loc(1,i)) + (loc(2,:) == unique_loc(2,i)) == 2) = i;
    end
    in_modes.similar_descriptors_indeces = AgglomerativeClustering(des,CLUSTERING_THRESHOLD,CLUSTERING_MINIMUM_SIZE,loc_ind);
    if strcmp(DISPLAY_MODE,'display')
        for i = 1:size(in_modes.similar_descriptors_indeces,2)
            marker_i = mod(i,size(marker,1))+1;
            colour_i = mod(i,size(colours,1))+1;
            plot(loc(1,nonzeros(in_modes.similar_descriptors_indeces(:,i))),loc(2,nonzeros(in_modes.similar_descriptors_indeces(:,i))),[marker(marker_i,:) colours(colour_i,:)])
        end
    end
end        

function similar_descriptor = find_cluster_descriptor(des)
    score = zeros(size(des,2),1);
    if (size(des,2) > 1)
        for i = 1:size(des,2)    
            current_des = des(:,i);        
            score(i) = sum(current_des'*des);
        end
        [val ind] = max(score);
    else
        ind = 1;
    end
    similar_descriptor = des(:,ind);
end

function des = descriptor_normalization(des)
     N_points = size(des,2);
     des = double(des);
     for j = 1:N_points
        des(:,j) = des(:,j)/norm(des(:,j));        
     end
end