function out = main(img1,img2,output_name,Fs_flag,run_BLOGS_flag,angles_flag,angles_list)    
    run('Others\vlfeat-0.9.9\toolbox\vl_setup')
    javaaddpath('Others\Weka-3-6\weka.jar');
    addpath(genpath('We'));            
    addpath(genpath('Others\BLOGS'));        
    addpath(genpath('Others\Weka-3-6'));    
    addpath('Others\sift-0.9.19');    
    global MAX_POINTS; MAX_POINTS = 4000;
    global MAX_NUM_POINTS; MAX_NUM_POINTS = 400;    
    global DISTRATIO; DISTRATIO = 0.9;    
    global TRESHOLD; TRESHOLD = 5;
    global GRID_CELL_SIZE; GRID_CELL_SIZE = 50;
    global CLUSTERING_THRESHOLD; CLUSTERING_THRESHOLD = 0.85;
    global CLUSTERING_MINIMUM_SIZE;CLUSTERING_MINIMUM_SIZE  = 1;        
    global CLUSTERING_CRITERIA;CLUSTERING_CRITERIA = 'minimum';% 'minimum' 'maximum' 'median'
    global TRESHOLD_SAME_POINT; TRESHOLD_SAME_POINT = 5;
    global GENERATE_LENGTH; GENERATE_LENGTH = 7;
    global F_BUILDING_FACTOR; F_BUILDING_FACTOR = 1; %importance of real points over virtual
    global K_SCALES; K_SCALES = 5;% 5
    global KNN;KNN = 5; %4
    global KNN_SCALES_MAX; KNN_SCALES_MAX = 100;
    global N_fm_after_weka; N_fm_after_weka = 100;
        
    [I1,loc_angles1,des_angles1] = one_image_analysis1(img1);
    [I2,loc_angles2,des_angles2] = one_image_analysis1(img2);
    [output.x_blogs, output.p_blogs] = blogs_match(des_angles1',loc_angles1,des_angles2',loc_angles2);
    [output.x_beem, output.distratio] = beem_match(des_angles1,loc_angles1,des_angles2,loc_angles2);
    if (angles_flag == 0)        
        output.angles_list = -100;
        in_modes1 = one_image_analysis2(I1,loc_angles1,des_angles1,-100);
    elseif (angles_flag == 2) && (nargin > 6)
        output.angles_list = angles_list;
        in_modes1 = one_image_analysis2(I1,loc_angles1,des_angles1,0);
    else
        output.angles_list = get_angles_list([output.x_beem([4 9],:) output.x_blogs([4 9],:)]);
        in_modes1 = one_image_analysis2(I1,loc_angles1,des_angles1,0);
    end        
    in_modes2 = one_image_analysis2(I2,loc_angles2,des_angles2,output.angles_list);
    clear I1 I2
    
    for i = 1:length(output.angles_list)
        H_match_temp1 = matching(in_modes1.similar_descriptors_values(:,:,1)',in_modes2.similar_descriptors_values(:,:,i)',1);
        H_match_temp2 = matching(in_modes2.similar_descriptors_values(:,:,i)',in_modes1.similar_descriptors_values(:,:,1)',1);                   
        H_match(i).match = unique([1:size(H_match_temp1,2) H_match_temp2;H_match_temp1 1:size(H_match_temp2,2)]','rows')';                        
        [output_struct(i).fm_without_neigbours, output_struct(i).all_fm_for_weka, output_struct(i).all_descriptor_for_weka] = Creatures(loc_angles1,loc_angles2,in_modes1.similar_descriptors_indeces,in_modes2.similar_descriptors_indeces,H_match(i).match,des_angles1,des_angles2,GRID_CELL_SIZE,KNN_SCALES_MAX,K_SCALES,TRESHOLD_SAME_POINT,KNN);
        save_arff('all.arff',output_struct(i).all_descriptor_for_weka');
        [output_struct(i).predictedClass, output_struct(i).classProbs] = weka_predictor('all.arff');        
        [sorted_fm, ind_fm] = sort(output_struct(i).classProbs(:,1),'descend');        
        if Fs_flag
            output_struct(i).all_fm_after_weka = output_struct(i).all_fm_for_weka(:,ind_fm(1:min(N_fm_after_weka,length(ind_fm))));
            [output(i).ordered_fm_sfms, output(i).sfms] = total_building_best_F(output_struct(i).all_fm_after_weka,output_struct(i).fm_without_neigbours);
            output = combining_probabilities(output,i);              
            un = get_no_dup_best_MAX_NUM_POINTS(output(i).ordered_fm([1:2 6:7],:)');
            out(i).matches = output(i).ordered_fm([1:4 6:9],un);       
            out(i).probabilities = output(i).probabilities(un);
        else
            output_struct(i).all_fm_after_weka = output_struct(i).all_fm_for_weka(:,ind_fm);            
            N_after_weka = 2*size(output_struct(i).all_fm_after_weka,2);
            all_fm_after_weka = reshape([output_struct(i).all_fm_after_weka([1:5 7:11],:); output_struct(i).all_fm_after_weka([13:17 19:23],:)],10,N_after_weka)';
            out(i).probabilities = reshape([sorted_fm sorted_fm]',1,N_after_weka);
            un = get_no_dup_best_MAX_NUM_POINTS(all_fm_after_weka(:,[1:2 6:7]));
            out(i).matches = all_fm_after_weka(un,[1:4 6:9])';            
            out(i).probabilities = out(i).probabilities(un);        
        end        
        clear output_struct
    end        
    save(output_name,'out');
    if run_BLOGS_flag
        BLOGS_after_us(img1,img2,out)        
    end
end

function ind = get_no_dup_best_MAX_NUM_POINTS(all)
    ind = remove_duplicates(all);
    ind = get_best_MAX_NUM_POINTS(ind);        
end

function [match, ratios] = matching(des1,des2,distratio)    
    match = zeros(1,size(des1,1));
    ratios = zeros(1,size(des1,1));    
    des2t = des2';                          % Precompute matrix transpose    
    for i = 1 : size(des1,1)        
        dotprods = des1(i,:) * des2t;        % Computes vector of dot products
        [vals,indx] = sort(acos(dotprods));  % Take inverse cosine and sort results                
        % Check if nearest neighbor has angle less than distRatio times 2nd.        
        if (vals(1) <= distratio* vals(2))            
            match(i) = indx(1);            
            ratios(i) = vals(1)/vals(2);            
        end        
    end
end

function [ordered_fm_sfms, sorted_sfms] = total_building_best_F(fm_for_building,fm_for_verification)
    global TRESHOLD
    global GENERATE_LENGTH
    
    if size(fm_for_building,2) > 1        
        all_possible_F = AllPossibleFFromPairs(fm_for_building,GENERATE_LENGTH)';
        inliers = all_possible_inliers_from_F(all_possible_F,fm_for_verification,TRESHOLD);     
        N_inliers = size(fm_for_verification,2);
        inliers_histogram = hist(reshape(inliers,1,numel(inliers)),0:1:N_inliers+1);
        sfms = inliers_histogram(2:N_inliers+1);        
        [sorted_sfms, inliers_ind] = sort(sfms,'descend');            
        ordered_fm_sfms= fm_for_verification([1:5 7:11],inliers_ind);        
    else
        ordered_fm_sfms = [];
        sorted_sfms = [];
    end
end

function [predictedClass, classProbs] = weka_predictor(filename)
    testData = loadARFF(filename);
    temp = javaObject('weka.core.SerializationHelper');
    filename = java.lang.String('We\J48.model');
%     filename_SVM = java.lang.String('C:\Documents and Settings\Maria\Desktop\31_07_13\Results\LibSVM.model'); 
    classifier = temp.read(filename);
%     classifier_SVM = temp.read(filename_SVM);
    [predictedClass, classProbs] = wekaClassify(testData,classifier);
%     [mdata,featureNames,targetNDX,stringVals,relationName] =weka2matlab(testData,[])
end

function inliers =  all_possible_inliers_from_F(all_possible_F,verification_set,t)        
    [loc ind] = unique(verification_set([1:2 7:8],:)','rows');
    N = size(all_possible_F,1);
    inliers = zeros(N,1);
    for i = 1:N
        [deviation_error dist]  = findFScore(reshape(all_possible_F(i,:),3,3),loc);
        temp_inliers = find(dist < t);
        if numel(temp_inliers)
            inliers(i,1:size(temp_inliers,1))  = ind(temp_inliers)';
        end
    end
end

function probabilities_from_Fs(file_name,pairs,sorted_number_of_Fs,F_inl_GT)
    pairs_loc = get_locations(pairs);    
    [val GT_ind] = intersect(pairs_loc',F_inl_GT','rows');
    current_number_of_Fs = sorted_number_of_Fs(1);
    i = 1;
    while current_number_of_Fs >= max(sorted_number_of_Fs(size(sorted_number_of_Fs,2)),1) 
        current_ind = find(sorted_number_of_Fs == current_number_of_Fs);
        N_GT(i) = size(intersect(GT_ind,current_ind),2);
        N_NON_GT(i) = size(current_ind,2) - N_GT(i);
        N_of_Fs(i) = current_number_of_Fs;
%         GT_fraction(i) = current_N_GT(i)/size(current_ind,2);
        i = i + 1;
        if max(current_ind) == size(sorted_number_of_Fs,2)
            break
        else
            current_number_of_Fs = sorted_number_of_Fs(max(current_ind)+1);
        end
    end
    save(['probabilities_from_Fs' file_name],'N_of_Fs','N_GT','N_NON_GT');
end

function save_arff(filename,data)
    fid = fopen(filename,'w');    
    fprintf(fid,'@relation fm\n');
    fprintf(fid,'@attribute N1 real\n');
    fprintf(fid,'@attribute N2 real\n');
    fprintf(fid,'@attribute dist_ratio real\n');
    fprintf(fid,'@attribute angle_difference real\n');
    fprintf(fid,'@attribute cluster_type {1, 0}\n');
    fprintf(fid,'@attribute min_dist real\n');
    fprintf(fid,'@attribute class {1,0}\n');
    fprintf(fid,'\n@data\n');
    fclose(fid);
    dlmwrite(filename,data, '-append');
end

function [x_beem,ratios] = beem_match( des1, loc1, des2, loc2)
    global DISTRATIO;
    
    ind = 1;
    des1t = des1';                          % Precompute matrix transpose    
    for i = 1:size(des1,2)        
        dotprods = des1t(i,:) * des2;        % Computes vector of dot products
        [vals,indx] = sort(acos(dotprods));  % Take inverse cosine and sort results                
        % Check if nearest neighbor has angle less than distRatio times 2nd.        
        if (vals(1) <= DISTRATIO* vals(2))            
            x1(:,ind) = loc1(:,i);
            x2(:,ind) = loc2(:,indx(1));
            ratios(ind) = vals(1)/vals(2);
            ind = ind + 1;
        end
    end
    x_beem = [x1; x2];
end

function [x_blogs, p] = blogs_match( des1, loc1, des2, loc2)    
     X = des1*des2';
     G = 1./(2*(1-X));
     
     if ((size(G,1) > 5000) || (size(G,2) > 5000))
         MX11 = zeros(1,size(G,1));
         IX1 = zeros(1,size(G,1));
         for i = 1:size(G,1)
             [MX11(i),IX1(i)] = max(G(i,:));
         end
     else
         H = G';
         [MX11,IX1] = max(H);
     end
     [MX21,IX2] = max(G);

     sz = size(des1,1);
     if(sz > size(des2,1))
         sz = size(des2,1);
     end
     
     if(size(des1,1)<2 || size(des2,1)<2)
        PhotoSim = 0;
     else
         if(IX1~=0)
             for i =  1: size(des1,1)
                H(IX1(i),i) = 0;
             end
         end

         if(IX2~=0)
             for j =  1: size(des2,1)
                G(IX2(j),j) = 0;
             end
         end

         MX12 = max(H);
         MX22 = max(G);
 
         a = (1-(MX12(:)./MX11(:))).*(1- exp(-MX11(:)));
         u = IX1(:);

         b = (1-(MX22(:)./MX21(:))).*(1- exp(-MX21(:)));
         v = IX2(:);

         count=0;
         for i = 1 : size(des1,1)     
             for j = 1 : size(des2,1)
                 if(((v(j)== i)&&(u(i)==j)))
                     count=count+1;
                 end
             end
         end

        MAPCONF = double(zeros(count,1));
        MAP = double(zeros(count,2));  

        count = 0;
        for i = 1 : size(des1,1)     
            for j = 1 : size(des2,1)
                if(((v(j)== i)&&(u(i)==j)))
                    count=count+1;
                    MAPCONF(count)= a(i)*b(j);
                    MAP(count,1)= i;
                    MAP(count,2)= j;    
                end
            end
        end

        [P, IX] = sort(MAPCONF,'descend');
        NEWMAP = double(zeros(count,2));  
        for i = 1 : count
            NEWMAP(i, 1) = MAP(IX(i), 1);
            NEWMAP(i, 2) = MAP(IX(i), 2);
        end

        x1 = double(zeros(5, count));
        x2 = double(zeros(5, count));

        for i = 1: count
             x1(1:5,i) = loc1(1:5,NEWMAP(i,1));     
             x2(1:5,i) = loc2(1:5,NEWMAP(i,2));
        end

        % select only distinct x1 and x2
        % remove those that appear later

        i = 1;
        while(i<count-1)
            j = i+1;
            while(j<count)
                if(((x1(1,i) == x1(1,j))&&(x1(2,i) == x1(2,j)))||((x2(1,i) == x2(1,j))&&(x2(2,i) == x2(2,j))))
                    for k = j : count-1
                        x1(:,k) = x1(:,k+1);
                        x2(:,k) = x2(:,k+1);
                        P(k) = P(k+1);
                    end
                    count = count - 1;
                    j = j - 1;
                end
                j = j+1;
            end
            i = i+1;
        end

        x1new = double(zeros(5, count));
        x2new = double(zeros(5, count));
        Pnew = double(zeros(count,1));

        for k = 1 : count
            x1new(:,k) = x1(:,k);
            x2new(:,k) = x2(:,k);
            Pnew(k) = P(k);
        end
%         p = cumsum(Pnew(:)'/sum(Pnew));
        p = Pnew;
     end
     x_blogs = [x1new; x2new];    
end